首页 > 代码库 > ACM-SG函数之S-Nim——hdu1536 hdu1944 poj2960
ACM-SG函数之S-Nim——hdu1536 hdu1944 poj2960
S-Nim
Time Limit: 5000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 4091 Accepted Submission(s): 1760
Problem Description
Arthur and his sister Caroll have been playing a game called Nim for some time now. Nim is played as follows:
The starting position has a number of heaps, all containing some, not necessarily equal, number of beads.
The players take turns chosing a heap and removing a positive number of beads from it.
The first player not able to make a move, loses.
Arthur and Caroll really enjoyed playing this simple game until they recently learned an easy way to always be able to find the best move:
Xor the number of beads in the heaps in the current position (i.e. if we have 2, 4 and 7 the xor-sum will be 1 as 2 xor 4 xor 7 = 1).
If the xor-sum is 0, too bad, you will lose.
Otherwise, move such that the xor-sum becomes 0. This is always possible.
It is quite easy to convince oneself that this works. Consider these facts:
The player that takes the last bead wins.
After the winning player‘s last move the xor-sum will be 0.
The xor-sum will change after every move.
Which means that if you make sure that the xor-sum always is 0 when you have made your move, your opponent will never be able to win, and, thus, you will win.
Understandibly it is no fun to play a game when both players know how to play perfectly (ignorance is bliss). Fourtunately, Arthur and Caroll soon came up with a similar game, S-Nim, that seemed to solve this problem. Each player is now only allowed to remove a number of beads in some predefined set S, e.g. if we have S =(2, 5) each player is only allowed to remove 2 or 5 beads. Now it is not always possible to make the xor-sum 0 and, thus, the strategy above is useless. Or is it?
your job is to write a program that determines if a position of S-Nim is a losing or a winning position. A position is a winning position if there is at least one move to a losing position. A position is a losing position if there are no moves to a losing position. This means, as expected, that a position with no legal moves is a losing position.
The starting position has a number of heaps, all containing some, not necessarily equal, number of beads.
The players take turns chosing a heap and removing a positive number of beads from it.
The first player not able to make a move, loses.
Arthur and Caroll really enjoyed playing this simple game until they recently learned an easy way to always be able to find the best move:
Xor the number of beads in the heaps in the current position (i.e. if we have 2, 4 and 7 the xor-sum will be 1 as 2 xor 4 xor 7 = 1).
If the xor-sum is 0, too bad, you will lose.
Otherwise, move such that the xor-sum becomes 0. This is always possible.
It is quite easy to convince oneself that this works. Consider these facts:
The player that takes the last bead wins.
After the winning player‘s last move the xor-sum will be 0.
The xor-sum will change after every move.
Which means that if you make sure that the xor-sum always is 0 when you have made your move, your opponent will never be able to win, and, thus, you will win.
Understandibly it is no fun to play a game when both players know how to play perfectly (ignorance is bliss). Fourtunately, Arthur and Caroll soon came up with a similar game, S-Nim, that seemed to solve this problem. Each player is now only allowed to remove a number of beads in some predefined set S, e.g. if we have S =(2, 5) each player is only allowed to remove 2 or 5 beads. Now it is not always possible to make the xor-sum 0 and, thus, the strategy above is useless. Or is it?
your job is to write a program that determines if a position of S-Nim is a losing or a winning position. A position is a winning position if there is at least one move to a losing position. A position is a losing position if there are no moves to a losing position. This means, as expected, that a position with no legal moves is a losing position.
Input
Input consists of a number of test cases. For each test case: The first line contains a number k (0 < k ≤ 100 describing the size of S, followed by k numbers si (0 < si ≤ 10000) describing S. The second line contains a number m (0 < m ≤ 100) describing the number of positions to evaluate. The next m lines each contain a number l (0 < l ≤ 100) describing the number of heaps and l numbers hi (0 ≤ hi ≤ 10000) describing the number of beads in the heaps. The last test case is followed by a 0 on a line of its own.
Output
For each position: If the described position is a winning position print a ‘W‘.If the described position is a losing position print an ‘L‘. Print a newline after each test case.
Sample Input
2 2 5 3 2 5 12 3 2 4 7 4 2 3 7 12 5 1 2 3 4 5 3 2 5 12 3 2 4 7 4 2 3 7 12 0
Sample Output
LWW WWL
Source
Norgesmesterskapet 2004
题目:http://acm.hdu.edu.cn/showproblem.php?pid=1536
这也是一道经典SG函数的题目。
有关于SG函数的解,能够戳这个,非常具体→http://blog.csdn.net/lttree/article/details/24886205
这道题题意:
我就按着例子格式来说吧:
先输入一个K,表示取数集合的个数。(K为0,则结束)
后面跟k个数,表示取数集合的数(就是每次仅仅能取这几个数量的物品)
然后会跟一个M,表示有M次询问。
然后接下来M行,每行先有一个N,表示有多少堆物品。
N后跟着N个数,表示每堆物品数量。
由于,OJ后台的操作,输入和输出是分开的(事实上就是将你的程序的答案存成一个TXT文件,然后和
标准答案TXT文件进行二进制的比較)
所以,我每一个N都直接输出‘L‘或者‘W‘,
在M行结束时,换行,没实用数组来存答案。
PS:用scanf比cin快80MS
/************************************************ ************************************************* * Author:Tree * *From :http://blog.csdn.net/lttree * * Title : S-Nim * *Source: hdu 1536 * * Hint : SG * ************************************************* *************************************************/ #include <stdio.h> #include <string.h> #include <algorithm> using namespace std; #define N 10001 int f[N],sg[N]; bool mex[N]; void get_sg(int t,int n) { int i,j; memset(sg,0,sizeof(sg)); for(i=1;i<=n;i++) { memset(mex,0,sizeof(mex)); // 对于属于g(x)后继的数置1 for( j=1 ;j<=t && f[j]<=i ;j++ ) mex[sg[i-f[j]]]=1; // 找到最小不属于该集合的数 for( j=0 ; j<=n ; j++ ) if(!mex[j]) break; sg[i] = j; } } int main() { int k,m,n,i,t,temp; while( scanf("%d",&k) && k ) { for(i=1;i<=k;++i) scanf("%d",&f[i]); sort(f+1,f+k+1); get_sg(k,N); scanf("%d",&m); while(m--) { temp=0; scanf("%d",&n); for(i=0;i<n;++i) { scanf("%d",&t); temp^=sg[t]; } if( !temp ) printf("L"); else printf("W"); } printf("\n"); } return 0; }
声明:以上内容来自用户投稿及互联网公开渠道收集整理发布,本网站不拥有所有权,未作人工编辑处理,也不承担相关法律责任,若内容有误或涉及侵权可进行投诉: 投诉/举报 工作人员会在5个工作日内联系你,一经查实,本站将立刻删除涉嫌侵权内容。